unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OpenGL, ExtCtrls, StdCtrls, Buttons, unit2, unit3, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    SpeedButton1: TSpeedButton;
    Label2: TLabel;
    Label3: TLabel;
    TrackBar1: TTrackBar;
    Label4: TLabel;
    TrackBar2: TTrackBar;
    Label5: TLabel;
    Label6: TLabel;
    TrackBar3: TTrackBar;
    Label7: TLabel;
    TrackBar4: TTrackBar;
    CheckBox1: TCheckBox;
    TrackBar5: TTrackBar;
    Label10: TLabel;
    Edit2: TEdit;
    BitBtn1: TBitBtn;
    Label9: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Timer1: TTimer;
    Label14: TLabel;
    Edit3: TEdit;
    Panel2: TPanel;
    Label15: TLabel;
    TrackBar6: TTrackBar;
    TrackBar7: TTrackBar;
    TrackBar8: TTrackBar;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label8: TLabel;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Button1: TButton;
    Panel3: TPanel;
    Label19: TLabel;
    Edit4: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure TrackBar4Change(Sender: TObject);
    procedure TrackBar6Change(Sender: TObject);
    procedure TrackBar7Change(Sender: TObject);
    procedure TrackBar8Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Edit3KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }

  ghRC:HGLRC;
  ghDC:HDC;
  procedure Draw;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
N,N1:byte;
lx,ly,lz:single;
flag1:boolean;
tstcntr:byte;
y2:integer;

 function bSetupPixelFormat(DC:HDC):boolean;
      var
          pfd:PIXELFORMATDESCRIPTOR;
          ppfd:PPIXELFORMATDESCRIPTOR;
          pixelformat:integer;
      begin
          ppfd := @pfd;
          ppfd.nSize := sizeof(PIXELFORMATDESCRIPTOR);
          ppfd.nVersion := 1;
          ppfd.dwFlags :=  PFD_DRAW_TO_WINDOW xor
                           PFD_SUPPORT_OPENGL xor
                           PFD_DOUBLEBUFFER;
          ppfd.dwLayerMask := PFD_MAIN_PLANE;
          ppfd.iPixelType := PFD_TYPE_RGBA;
          ppfd.cColorBits := 16;           
          ppfd.cDepthBits := 16;
          ppfd.cAccumBits := 0;
          ppfd.cStencilBits := 0;
          pixelformat := ChoosePixelFormat(dc, ppfd);
          if pixelformat=0 then
          begin
              MessageBox(0, '    ', '!', MB_OK);
              bSetupPixelFormat:=FALSE;
              exit;
          end;
          if SetPixelFormat(dc, pixelformat, ppfd)=false then
          begin
              MessageBox(0, '    ', '!', MB_OK);
              bSetupPixelFormat:=FALSE;
              exit;
          end;
          bSetupPixelFormat:=TRUE;
 end;

procedure Plate;
  var
  i,j:byte;
begin
  glLineWidth(1);
    glColor3f(0.6,0.6,0.8);
glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
        glBegin(GL_QUADS);
        glVertex3f(-60,-51,-60);
        glVertex3f(60, -51,-60);
        glVertex3f(60, -51, 60);
        glVertex3f(-60,-51, 60);
        glEnd;
glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
    glColor3f(0,0,0);
    for j:=0 to 14 do
    for i:=0 to 14 do begin
        glBegin(GL_QUADS);
        glVertex3f(i*8-60,-50,j*8-60);
        glVertex3f(i*8-20, -50,j*8-60);
        glVertex3f(i*8-20, -50, j*8-20);
        glVertex3f(i*8-60,-50, j*8-20);
        glEnd;
    end;
glLineWidth(3);
    for j:=0 to 2 do
    for i:=0 to 2 do begin
        glBegin(GL_QUADS);
        glVertex3f(i*40-60,-50,j*40-60);
        glVertex3f(i*40-20, -50,j*40-60);
        glVertex3f(i*40-20, -50, j*40-20);
        glVertex3f(i*40-60,-50, j*40-20);
        glEnd;
    end;
end;

function CalcE(x,y,xx,yy:shortint;teta:single):single;
var
dx,dy:shortint;
begin
dx:=xx-x;
dy:=yy-y;
Result:=1/(teta*SQRT(2*PI))*EXP(-(dx*dx+dy*dy)/(2*teta*teta));
end;

function gr_to_r(x:single):single;
begin
Result:=x*PI/180;
end;

procedure TForm1.FormCreate(Sender: TObject);
      var
         p: TGLArrayf4;
         d: TGLArrayf3;
         q: TGLArrayf3;
         l1: TGLArrayf4;
         l2: TGLArrayf3;
         l3: TGLArrayf3;
      begin
         ghDC := GetDC(Handle);
         if bSetupPixelFormat(ghDC)=false then
           Close();
         ghRC := wglCreateContext(ghDC);
         wglMakeCurrent(ghDC, ghRC);
         glClearColor(0, 0, 0, 0);
         FormResize(Sender);
         glEnable(GL_COLOR_MATERIAL);
         glEnable(GL_DEPTH_TEST);
         glEnable(GL_LIGHTING);
         glEnable(GL_LIGHT0);
           p[0]:=3;
           p[1]:=3;
           p[2]:=3;
           p[3]:=1;
           d[0]:=-1;
           d[1]:=-1;
           d[2]:=-3;
           q[0]:=0.3;
           q[1]:=0.6;
           q[2]:=0.5;
         glLightfv(GL_LIGHT0,GL_POSITION,@p);
         glLightfv(GL_LIGHT0,GL_SPOT_DIRECTION,@d);
         glLightfv(GL_LIGHT0,GL_AMBIENT,@q);
         l1[0]:=0;
         l1[1]:=50;
         l1[2]:=0;
         l1[3]:=0.3;
         l2[0]:=0;
         l2[1]:=1;
         l2[2]:=0;
         l3[0]:=0.8;
         l3[1]:=0.8;
         l3[2]:=0.8;
         glLightfv(GL_LIGHT1,GL_POSITION,@l1);
         glLightfv(GL_LIGHT1,GL_SPOT_DIRECTION,@l2);
         glLightfv(GL_LIGHT1,GL_DIFFUSE,@d);
         glEnable(GL_POINT_SMOOTH);
         N:=0; N1:=0;
         lx:=0;ly:=0;lz:=0;
         Flag1:=false;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  glViewport( 10, 10, Width-200, Height-50 );
  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();
  glOrtho(-100,100, -100,100, -100,100);
  gluLookAt(0,0,5, 0,0,0, 0,1,0);
  glMatrixMode( GL_MODELVIEW );
  glPushMatrix;
  Draw;
  SwapBuffers(ghDC);
end;

  procedure TForm1.Draw;
  var
  teta,P:single;
  i,j,x1,x2,y1,y2,xd,yd,sqx,sqy,cntr:shortint;
  sqxmin,sqymin,sqxmax,sqymax:shortint;
  E1,E2,E3,cmpr:single;
  Nmax:byte;
  begin
  teta:=StrToFloat(form1.Edit1.Text);
  Nmax:=StrToInt(Edit2.Text);
  cmpr:=StrToFloat(Edit3.Text);
  x1:=TrackBar1.Position;
  y1:=TrackBar2.Position;
  x2:=TrackBar3.Position;
  y2:=TrackBar4.Position;
  glClear(GL_DEPTH_BUFFER_BIT xor GL_COLOR_BUFFER_BIT);
  Plate;
  glColor3f(1.4,0,1.4);
  glPointSize(3);
  glBegin(GL_POINTS);
  glVertex3f(x1,60,y1);
  glEnd;
  glColor3f(0.6,0.62,1);
  glBegin(GL_POINTS);
  glVertex3f(x2,60,y2);
  glEnd;
  glLineWidth(1);
  glColor3f(0.7,0,0);
        glBegin(GL_LINES);
        glVertex3f(x1,60,y1);
        glVertex3f(x1,-50,y1);
        glVertex3f(x2,60,y2);
        glVertex3f(x2,-50,y2);        
        glEnd;
  xd:=(x1+x2)div 2;yd:=(y1+Y2) div 2;
  sqx:=trunc(xd/7);
  sqy:=trunc(yd/7);
  if sqx>7 then sqx:=7;
  if sqy>7 then sqy:=7;
  if sqx<-7 then sqx:=-7;
  if sqy<-7 then sqy:=-7;
  sqxmin:=sqx*8-4; sqxmax:=sqx*8+4;
  sqymin:=sqy*8-4; sqymax:=sqy*8+4;
  glColor3f(1.2,1,1);
  glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
        glBegin(GL_QUADS);
        glVertex3f(sqxmin,-50,sqymin);
        glVertex3f(sqxmax,-50,sqymin);
        glVertex3f(sqxmax,-50,sqymax);
        glVertex3f(sqxmin,-50,sqymax);
  glEnd;
  glColor3f(0,0.7,0);
        glBegin(GL_LINES);
        glVertex3f(xd,0,yd);
        glVertex3f(xd,-50,yd);
  glEnd;
  E3:=0; cntr:=0;
  glColor3f(0.8,0.6,0.1);
  glPolygonMode(GL_FRONT_AND_BACK,GL_POINT);
  glPointSize(2);
  glBegin(GL_TRIANGLE_STRIP);
  for i:=-60 to 60 do
  for j:=-60 to 60 do begin
  E1:=CalcE(i,j,x1,y1,teta)*1200;
  E2:=CalcE(i,j,x2,y2,teta)*1200;
  if CheckBox1.Checked then begin
  E1:=E1+Random(TrackBar5.Position);
  E2:=E2+Random(TrackBar5.Position);
  end;
  if (i>sqxmin) and (i<sqxmax) then
  if (j>sqymin) and (j<sqymax) then begin
  E3:=E3+E1+E2;
  inc(cntr);
  end;
  glVertex3f(i,E1+E2-52,j);
  end;
  glEnd;
  E1:=(CalcE(x1,y1,x1,y1,teta)+CalcE(x1,y1,x2,y2,teta))*1200;
  E2:=(CalcE(x2,y2,x1,y1,teta)+CalcE(x2,y2,x2,y2,teta))*1200;
  E3:=E3/cntr;
  if CheckBox1.Checked then begin
  E1:=E1+Random(TrackBar5.Position);
  E2:=E2+Random(TrackBar5.Position);
  end;
  if (E1-E3>=cmpr*E1) and (E2-E3>=cmpr*E2) then inc(N1);
  inc(N);
  if N=Nmax then begin
  P:=N1/N;
  N:=0; N1:=0;
  Edit4.Text:=FloatToStr(trunc(P*100)/100);
  end;
  end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
      begin
        if ghRC<>0 then
        begin
          wglMakeCurrent(ghDC,0);
          wglDeleteContext(ghRC);
        end;
        if ghDC<>0 then
          ReleaseDC(Handle, ghDC);
      end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
if Flag1 then begin
if CheckBox2.Checked then begin
TrackBar3.Position:=tstcntr-60;
TrackBar4.Position:=tstcntr-60;
Label12.Caption:=IntToStr(tstcntr-60);
Label13.Caption:=IntToStr(tstcntr-60);
end;
if Checkbox3.Checked then TrackBar5.Position:=trunc(tstcntr/4);
if CheckBox4.Checked then Edit3.Text:=FloatToStr(trunc(tstcntr/1.2)/100);
if N=1 then inc(tstcntr);
if tstcntr>1 then form3.Canvas.LineTo(10+trunc(tstcntr*4),y2-trunc(StrToFloat(Edit4.Text)*200));
if tstcntr=121 then begin
Flag1:=false;
CheckBox1.Enabled:=true;
CheckBox2.Enabled:=true;
CheckBox3.Enabled:=true;
TrackBar1.Enabled:=true;
TrackBar2.Enabled:=true;
TrackBar3.Enabled:=true;
TrackBar4.Enabled:=true;
TrackBar5.Enabled:=true;
Edit1.Enabled:=true;
Edit2.Enabled:=true;
Edit3.Enabled:=true;
CheckBox1.Enabled:=true;
Checkbox2.Enabled:=true;
Checkbox3.Enabled:=true;
Checkbox4.Enabled:=true;
Button1.Caption:='!';
end;
end;
Draw;
   SwapBuffers(ghDC);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
AboutBox.Show;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
if CheckBox1.Checked then TrackBar5.Enabled:=true
else TrackBar5.Enabled:=false;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
Form1.Close;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
Label9.Caption:=IntToStr(TrackBar1.Position);
end;

procedure TForm1.TrackBar2Change(Sender: TObject);
begin
Label11.Caption:=IntToStr(TrackBar2.Position);
end;

procedure TForm1.TrackBar3Change(Sender: TObject);
begin
Label12.Caption:=IntToStr(TrackBar3.Position);
end;

procedure TForm1.TrackBar4Change(Sender: TObject);
begin
Label13.Caption:=IntToStr(TrackBar4.Position);
end;

procedure TForm1.TrackBar6Change(Sender: TObject);
begin
glRotatef(TrackBar6.Position-lx,1,0,0);
lx:=TrackBar6.Position;
end;

procedure TForm1.TrackBar7Change(Sender: TObject);
begin
glRotatef(TrackBar7.Position-ly,0,1,0);
ly:=TrackBar7.Position;
end;

procedure TForm1.TrackBar8Change(Sender: TObject);
begin
glRotatef(TrackBar8.Position-lz,0,0,1);
lz:=TrackBar8.Position;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
x2,pred,pred2:integer;
i:byte;
begin
if Flag1 then begin
Flag1:=false;
CheckBox1.Enabled:=true;
CheckBox2.Enabled:=true;
CheckBox3.Enabled:=true;
TrackBar1.Enabled:=true;
TrackBar2.Enabled:=true;
TrackBar3.Enabled:=true;
TrackBar4.Enabled:=true;
TrackBar5.Enabled:=true;
Edit1.Enabled:=true;
Edit2.Enabled:=true;
Edit3.Enabled:=true;
CheckBox1.Enabled:=true;
Checkbox2.Enabled:=true;
Checkbox3.Enabled:=true;
Checkbox4.Enabled:=true;
Button1.Caption:='!';
end else begin
CheckBox1.Enabled:=false;
CheckBox2.Enabled:=false;
CheckBox3.Enabled:=false;
TrackBar1.Enabled:=false;
TrackBar2.Enabled:=false;
TrackBar3.Enabled:=false;
TrackBar4.Enabled:=false;
TrackBar5.Enabled:=false;
Edit1.Enabled:=false;
Edit2.Enabled:=false;
Edit3.Enabled:=false;
CheckBox1.Enabled:=false;
Checkbox2.Enabled:=false;
Checkbox3.Enabled:=false;
Checkbox4.Enabled:=false;
if Checkbox3.Checked then CheckBox1.Checked:=true;
tstcntr:=0;
Button1.Caption:='';
form3.Left:=screen.DesktopRect.Right-form3.Width;
form3.Top:=screen.DesktopTop;
x2:=form3.Width-10; y2:=form3.Height-40;
with form3.Canvas do begin
Form3.Show;
  Brush.Color:= ClBlack;
  FillRect(ClipRect);
  Pen.Style:=psSolid;
  Pen.Color:=ClWhite;
  Pen.Width:=3;
  MoveTo(10,0);
  LineTo(10,y2);
  LineTo(x2,y2);
  pred:=trunc((x2-10)/10);
  for i:=1 to 10 do begin
  MoveTo(10+pred*i,y2-5);
  LineTo(10+pred*i,y2+5);
  end;
  pred2:=trunc((y2-10)/10);
  for i:=1 to 10 do begin
  MoveTo(5,y2-pred2*i);
  LineTo(15,y2-pred2*i);
  end;
  Pen.Width:=1;
  Pen.Style:=psDot;
  Pen.Color:=ClSilver;
  for i:=1 to 10 do begin
  MoveTo(10+pred*i,y2);
  LineTo(10+pred*i,0);
  end;
  for i:=1 to 10 do begin
  MoveTo(10,y2-pred2*i);
  LineTo(x2,y2-pred2*i);
  end;
MoveTo(10,y2-200);
  Pen.Style:=psSolid;
  Pen.Color:=ClLime;
end;
Flag1:=true;
end;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  case key of
    '0'..'9': ;
    #8: ;
    '.', ',':
      if Pos(DecimalSeparator, Edit1.Text) = 0 then
        Key := DecimalSeparator
      else
        Key := #0;
    else
      key := #0;
  end;
end;

procedure TForm1.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  case key of
    '0'..'9': ;
    #8: ;
    '.', ',':
      if Pos(DecimalSeparator, Edit2.Text) = 0 then
        Key := DecimalSeparator
      else
        Key := #0;
    else
      key := #0;
  end;
end;

procedure TForm1.Edit3KeyPress(Sender: TObject; var Key: Char);
begin
  case key of
    '0'..'9': ;
    #8: ;
    '.', ',':
      if Pos(DecimalSeparator, Edit3.Text) = 0 then
        Key := DecimalSeparator
      else
        Key := #0;
    else
      key := #0;
  end;
end;

end.
